SpeechBubble = class({
  text = "Another boring day in purgatory",
  x = 0,
  y = 0,
  width = 100,
  height = 100
}, {collidable})

function wrappy(text, font, width)
  local output = ""
  local line = ""
  for _, word in pairs(split(text, " ")) do
    local line_width = font:getWidth(line .. " " .. word)
    if line_width > width then
      output = output .. "\n" .. line
      line = word
    else
      line = line .. " " .. word
    end
  end
  output = output .. "\n" .. line
  return output:gsub("^\n+", "")
end
font = love.graphics.newFont("fonts/plooploo.ttf", 20)
love.graphics.setFont(font)

function getTextHeight(string, font)
  local lines = #split(string, "\n")
  return font:getHeight() * lines
end

draw_stream.map(function()
  for _, bubble in pairs(SpeechBubble.instances.values()) do
    if bubble.text and bubble.text ~= "" then
      local width = 100
      local wrapped_text = wrappy(bubble.text, font, width)
      local border = 10
      love.graphics.setColor(colors.yellow)
      love.graphics.rectangle("fill", bubble.x - border, bubble.y - border, font:getWidth(wrapped_text) + border * 2, getTextHeight(wrapped_text, font) + border * 2)
      love.graphics.setColor(0, 0, 0, 255)
      love.graphics.print(wrapped_text, bubble.x, bubble.y)
    end
  end
  love.graphics.setColor(255, 255, 255, 255)
end)

SpeechBubble.instances.added
  .delay(2)
  .map(function(value)
    value.destroy()
  end)
